{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";
    nix-systems.url = "github:nix-systems/default-linux";
  };

  outputs =
    inputs:
    with inputs;
    let
      forAllSystems =
        function:
        nixpkgs.lib.genAttrs (import nix-systems) (system: function nixpkgs.legacyPackages.${system});
    in
    {
      packages =
        preferredNix:
        forAllSystems (pkgs: {
          default = pkgs.writeShellApplication {
            name = "smooooth";
            runtimeInputs = builtins.getAttrs {
              inherit (pkgs)
                polkit
                gnugrep
                coreutils
                libnotify
                ;
              inherit preferredNix;
            };
            text = builtins.readFile ./smooooth.sh;
          };
        });
      nixosModules.smooooth = import ./module.nix { inherit self; };
    };
}
